package gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import javax.swing.border.EmptyBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;


public class JPopupSliderTest extends JFrame
{	private JPopupSlider redPS,greenPS,bluePS;
	private JLabel showColour;
	private int colourValue=0x777777;

	public JPopupSliderTest()
	{	super("JPopupSlider Test");
	
		Runnable r = new Runnable()
		{	public void run() { initGUI(); }
		};
		SwingUtilities.invokeLater(r);
	}
	
	private void initGUI()
	{	Container c = getContentPane();
		c.setLayout(new BorderLayout(5,5));
		
		c.add(initColourChooser(),BorderLayout.CENTER);
		c.add(initOtherStuff(),BorderLayout.SOUTH);
		
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.setLocationByPlatform(true);
		this.pack();  this.setVisible(true);
	}

	private JPanel initColourChooser()
	{	// -----Colour selector
		ChangeListener l = new ChangeListener()
		{	public void stateChanged(ChangeEvent ev)
			{	JPopupSlider ps = (JPopupSlider)ev.getSource();
				if(ps==redPS)
					colourValue=(colourValue&0x00ffff) + ((redPS.getValue()&0xff)<<16);
				else if(ps==greenPS)
					colourValue=(colourValue&0xff00ff) + ((greenPS.getValue()&0xff)<<8);
				else if(ps==bluePS)
					colourValue=(colourValue&0xffff00) + ((bluePS.getValue()&0xff));
				
				showColour.setBackground(new Color(colourValue));
			}
		};
		
		redPS = new JPopupSlider
		(	JPopupSlider.HORIZONTAL,
			(colourValue>>16)&0xff,0,255,
			false,false,false
		);
		redPS.addChangeListener(l);
		
		greenPS = new JPopupSlider
		(	JPopupSlider.HORIZONTAL,
			(colourValue>>8)&0xff,0,255,
			false,false,false
		);
		greenPS.addChangeListener(l);
		
		bluePS = new JPopupSlider
		(	JPopupSlider.HORIZONTAL,
			colourValue&0xff,0,255,
			false,false,false
		);
		bluePS.addChangeListener(l);
		
		showColour = new JLabel("          ");	// FIXME: Crude resizing
		showColour.setBackground(new Color(colourValue));
		showColour.setOpaque(true);
		
		JPanel sliderP = new JPanel(new GridLayout(0,1 , 5,5));
		sliderP.add(redPS);
		sliderP.add(greenPS);
		sliderP.add(bluePS);

		JPanel labelP = new JPanel(new GridLayout(0,1 , 5,5));
		labelP.add(new JLabel("R:"));  		
		labelP.add(new JLabel("G:"));  		
		labelP.add(new JLabel("B:"));
		
		JPanel sliderLabelsP = new JPanel(new BorderLayout());
		sliderLabelsP.add(labelP,BorderLayout.WEST);		
		sliderLabelsP.add(sliderP,BorderLayout.CENTER);		

		JPanel allP = new JPanel(new BorderLayout(5,5));
		allP.add(sliderLabelsP,BorderLayout.WEST);
		allP.add(showColour,BorderLayout.CENTER);
		allP.setBorder(new EmptyBorder(5,10,5,10));
		
		return allP;
	}
	
	private JPanel initOtherStuff()
	{	FlowLayout lay = new FlowLayout();
		lay.setHgap(10);
		JPanel mainP = new JPanel(lay);
		mainP.add
		(	new JPopupSlider(JPopupSlider.HORIZONTAL , 50,0,100 , true,false,true)
		);
		mainP.add
		(	new JPopupSlider(JPopupSlider.HORIZONTAL , 90,0,200 , false,true,false)
		);
		mainP.add
		(	new JPopupSlider(JPopupSlider.VERTICAL , 15,8,18 , false,false,false)
		);
		mainP.add
		(	new JPopupSlider(JPopupSlider.VERTICAL , 16,25,75 , true,false,true)
		);
		return mainP;
	}	

	public static void main(String[] args) { new JPopupSliderTest(); }
}
